express.hpp File Reference
`#include <restinio/router/impl/target_path_holder.hpp>`
`#include <restinio/router/non_matched_request_handler.hpp>`
`#include <restinio/optional.hpp>`
`#include <restinio/path2regex/path2regex.hpp>`
`#include <restinio/router/std_regex_engine.hpp>`
`#include <restinio/router/method_matcher.hpp>`
`#include <restinio/utils/from_string.hpp>`
`#include <restinio/utils/percent_encoding.hpp>`
`#include <map>`
`#include <vector>`

Go to the source code of this file.

## Classes

class | restinio::router::route_params_t
| Parameters extracted from route. More...
struct | restinio::router::impl::route_params_accessor_t
| Route params private internals accessor. More...
class | restinio::router::impl::route_params_appender_t
| Helper class for gthering parameters from route. More...
class | restinio::router::impl::route_matcher_t< Regex_Engine >
| A matcher for a given path. More...
class | restinio::router::generic_express_route_entry_t< Regex_Engine, Extra_Data_Factory >
| A single generic express route entry. More...
class | restinio::router::generic_express_router_t< Regex_Engine, Extra_Data_Factory >
| Generic Express.js style router. More...

## Namespaces

namespace | restinio
namespace | restinio::router
namespace | restinio::router::impl

## Typedefs

using | restinio::router::impl::param_appender_sequence_t = path2regex::param_appender_sequence_t< route_params_appender_t >
template<typename Extra_Data >
using | restinio::router::generic_express_request_handler_t = std::function< request_handling_status_t(generic_request_handle_t< Extra_Data >, route_params_t) >
| Type of generic handler for one route. More...
using | restinio::router::express_request_handler_t = generic_express_request_handler_t< no_extra_data_factory_t::data_t >
| Type of a handler for one route in the case when there is no extra-data in request object. More...
template<typename Regex_Engine = std_regex_engine_t>
using | restinio::router::express_route_entry_t = generic_express_route_entry_t< Regex_Engine, no_extra_data_factory_t >
| An alias for a single route entry in the case when the default extra-data-factory is used in server's traits. More...
template<typename Regex_Engine = std_regex_engine_t>
using | restinio::router::express_router_t = generic_express_router_t< Regex_Engine, no_extra_data_factory_t >
| A type of express-like router for the case when the default extra-data-factory is specified in the server's traits. More...

## Functions

template<typename Value_Type >
Value_Type | restinio::get (const router::route_params_t &params, string_view_t key)
| Cast named parameter value to a given type. More...
template<typename Value_Type >
Value_Type | restinio::get (const router::route_params_t &params, std::size_t index)
| Cast indexed parameter value to a given type. More...